
local GreatLadder = ...

-- Register great ladder prefab nodes
GreatLadder:registerAssetId("models/greatLadder.fbx/Prefab/greatLadder/step_0_RootPart", _GreatLadderPrefix .. "_ROOT_PREFAB")
GreatLadder:registerAssetId("models/greatLadder.fbx/Prefab/greatLadder/step_3_TopPart", _GreatLadderPrefix .. "_TOP_PREFAB")
GreatLadder:registerAssetId("models/greatLadder.fbx/Prefab/greatLadder/step_2_Tiling2Part", _GreatLadderPrefix .. "_TILING2_PREFAB")
GreatLadder:registerAssetId("models/greatLadder.fbx/Prefab/greatLadder/step_1_Tiling3Part", _GreatLadderPrefix .. "_TILING3_PREFAB")
--------------------------------------------------------------------------

-- Create default building part registering function 
function registerDefaultBuildingPart(_nodePrefix)
	GreatLadder:register({
		DataType = "BUILDING_PART",
		Id = _nodePrefix .. "_PART",
		Mover = { DataType = "BUILDING_PART_MOVER" },
		ConstructorData = { DataType = "BUILDING_CONSTRUCTOR_DEFAULT", CoreObjectPrefab = _nodePrefix .. "_PREFAB" }
	})
end

local defaultNodePrefixList = {
	_GreatLadderPrefix .. "_TOP",
	_GreatLadderPrefix .. "_TILING2",
	_GreatLadderPrefix .. "_TILING3"
}

-- Register simple building part assets
for i, nodePrefix in ipairs(defaultNodePrefixList) do
	registerDefaultBuildingPart(nodePrefix)
end

--------------------------------------------------------------------------

-- Register the great ladder part
GreatLadder:register({
	DataType = "BUILDING_PART",
	Id = _GreatLadderPrefix .. "_ROOT_PART",
	Name = _GreatLadderPrefix .. "1_NAME",
	Description = _GreatLadderPrefix .. "1_DESC",
	Category = "CORE",
        BuildingZone = _GreatLadderBuildingZone,
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER", -- Since there are different types of building constructor, 'DataType' is necessary here
		CoreObjectPrefab = _GreatLadderPrefix .. "_ROOT_PREFAB",
		EndPart = _GreatLadderPrefix .. "_TOP_PART",
		FillerList = {
			_GreatLadderPrefix .. "_TILING2_PART"
                },
		BasementFillerList = {
			_GreatLadderPrefix .. "_TILING3_PART"
         	},
		MinimumScale = 1,
		BasementScale = 1,
		IsVertical = true
	},
--Les ressources ncessaires.
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = {
			{ Resource = "WOOD", Quantity = 1 }
		}
	}
})

-- Register grounding components

GreatLadder:registerPrefabComponent("models/greatLadder.fbx/Prefab/greatLadder/step_0_RootPart", {
	DataType = "COMP_GROUNDED"
})

-- Override building part components properties (generated by the building asset processor) to add building zones

GreatLadder:registerPrefabComponent("models/greatLadder.fbx/Prefab/greatLadder/step_0_RootPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 1, 1 }
})
